unit uLabyrinth1; // eine erste Lsung zum Labyrinth-Problem 

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TLaby = class(TForm)
    iBild: TImage;
    bZeige: TButton; l_nr: TLabel;
    lb_nr: TListBox;
    lZeige: TLabel;
    procedure bZeigeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    m               : array[1..7,1..9] of byte;
    zei_s,spa_s     : byte; // Startzeile und -spalte
    lz,lza          : byte; // Lsungszhler, Zhler fr angezeigte Lsung
    liste_aufgebaut : boolean;
    procedure gib_aus;
  end;

var
  Laby            : TLaby;

implementation

{$R *.DFM}

procedure TLaby.gib_aus;
const
  offsetX = 150;  // Abstand von links in Pixel
  offsetY = 80;   // Abstand von oben in Pixel
  d       = 40;   // Breite und Hhe der Felder
var
  zei,spa : byte;
begin
  for zei := 1 to 7 do
    for spa := 1 to 9 do
      begin
        with Laby.iBild.Canvas do
        begin
          if m[zei,spa] = 1 then brush.color := clBlack;  // Wand
          if m[zei,spa] = 0 then brush.color := clWhite;  // frei
          if m[zei,spa] = 2 then brush.color := clYellow; // Weg
          Rectangle(offsetX+(spa-1)*d,offsetY+(zei-1)*d,
                    offsetX+spa*d,offsetY+zei*d);
        end;
      end;
end;

procedure TLaby.bZeigeClick(Sender: TObject);
var
  slz : string;

  procedure untersuche(zei,spa : byte);
  begin
    if m[zei,spa] = 0  // nicht markiert, keine Wand
    then
      begin
        m[zei,spa] := 2; // Markierung setzen
        if (spa>1) and (spa<9) and (zei>1) and (zei<7) // wahr, wenn nicht am Rand
        then
          begin
            untersuche(zei,spa+1); // rechts
            untersuche(zei-1,spa); // oben
            untersuche(zei,spa-1); // links
            untersuche(zei+1,spa); // unten
          end
        else // Markierung sitzt am Rand
          begin
            inc(lz); // Lsungszhler erhhen
            if not liste_aufgebaut
            then begin Str(lz,slz); Lb_nr.Items.Add(slz); end;
            if lz = lza then gib_aus; // Lsung nur ausgeben, wenn verlangt
          end;
        m[zei,spa] := 0; // Markierung zurcknehmen
      end;
  end; // of untersuche

begin
  lz := 0; lZeige.Caption := 'Suche luft ...';
  // ItemIndex gibt die Nummer ( 0..) des ausgewhlten Listeneintrags an
  if liste_aufgebaut then begin lza := lb_nr.ItemIndex+1 end;
  untersuche(zei_s,spa_s);
  if lb_nr.Items.Count > 0 // es gibt Lsungen
  then
    begin lb_nr.ItemIndex := lza-1; liste_aufgebaut := true; end
  else lZeige.caption := 'Es gibt keine Lsung !';
  lZeige.caption := '';
end;

procedure TLaby.FormCreate(Sender: TObject);
begin
  zei_s := 4;   // Startzeile
  spa_s := 6;   // Startspalte
  lza := 1;     // zunchst erstmgliche Lsung anzeigen
  liste_aufgebaut := false; // Zu Beginn ist die Liste leer
  m[1,1] := 1; m[1,2] := 1; m[1,3] := 1; m[1,4] := 1; m[1,5] := 0;
  m[1,6] := 1; m[1,7] := 1; m[1,8] := 1; m[1,9] := 1;
  m[2,1] := 1; m[2,2] := 0; m[2,3] := 1; m[2,4] := 0; m[2,5] := 0;
  m[2,6] := 0; m[2,7] := 0; m[2,8] := 0; m[2,9] := 1;
  m[3,1] := 1; m[3,3] := 0; m[3,3] := 1; m[3,4] := 1; m[3,5] := 0;
  m[3,6] := 1; m[3,7] := 1; m[3,8] := 1; m[3,9] := 1;
  m[4,1] := 1; m[4,2] := 0; m[4,3] := 0; m[4,4] := 0; m[4,5] := 0;
  m[4,6] := 0; m[4,7] := 0; m[4,8] := 0; m[4,9] := 1;
  m[5,1] := 1; m[5,2] := 0; m[5,3] := 1; m[5,4] := 1; m[5,5] := 1;
  m[5,6] := 1; m[5,7] := 1; m[5,8] := 0; m[5,9] := 1;
  m[6,1] := 0; m[6,2] := 0; m[6,3] := 1; m[6,4] := 0; m[6,5] := 0;
  m[6,6] := 0; m[6,7] := 0; m[6,8] := 0; m[6,9] := 1;
  m[7,1] := 1; m[7,2] := 1; m[7,3] := 1; m[7,4] := 1; m[7,5] := 1;
  m[7,6] := 0; m[7,7] := 1; m[7,8] := 1; m[7,9] := 1;
  m[zei_s,spa_s] := 2; // belegen fr Zeichnung
  gib_aus;
  m[zei_s,spa_s] := 0; // wieder freimachen fr Backtracking

end;

end.
